@inproceedings{Artho04-blatomicity,
  author={C. Artho and A. Biere and K. Havelund},
  title = {Using block-local atomicity to detect stale-value concurrency errors},
  booktitle = {Proc.\ 2nd Intl.\ Symposium on Automated Technology for Verification and Analysis (ATVA~2004)},
  year={2004},
  pages = {150--164},
  series = {LNCS},
  volume = {3299},
  publisher = {Springer},
  address = {Taipei, Taiwan},
}

@inproceedings{kim01java-mac,
  author = {M. Kim and S. Kannan and I. Lee and O. Sokolsky and M. Viswanathan},
  title = {{Java-MaC}: a Run-time Assurance Tool for {J}ava Programs},
  booktitle = {Proc.~Run-Time Verification Workshop (RV'01)},
  series = {ENTCS},
  volume = {55},
  year = {2001},
  publisher = {Elsevier},
}

@inproceedings{
    bull99methodology,
    author = "J. Bull and L. Smith and M. Westhead and D. Henty and R. Davey",
    title = "A Methodology for Benchmarking {J}ava {G}rande Applications",
    booktitle = "Proc.~ACM Java Grande Conference",
    year = "1999",
}

@inproceedings{purify,
  title       = {{Purify}: Fast Detection of Memory Leaks and Access Errors},
  author = "R. Hastings and B. Joyce",
  booktitle = "Proc.~Winter USENIX Conf.~(USENIX'92)",
  year        = "1992",
}

@InProceedings{Haehnle00a,
  author =       {W. Ahrendt et al.},
  title =        {The {KeY} Approach: {I}ntegrating Object Oriented
                  Design and Formal Verification},
  editor =       "M. Ojeda-Aciego and I. de Guzm\'{a}n and
                  G. Brewka and L. Pereira",
  series =       lnai,
  volume =       1919,
  year =         "2000",
  booktitle =    "Proc.~JELIA",
  publisher =    spv,
}

@book{Holzmann91,
   author = {G. Holzmann},
   title = {Design and Validation of Computer Protocols},
   publisher = {Prentice-Hall},
   year = {1991}
}

@inproceedings{CousotCousot77-1,
   author =    {P. Cousot and R. Cousot},
   title =     {Abstract interpretation: a unified lattice model for static 
                analysis of programs by construction or approximation of 
                fixpoints},
   booktitle = {Proc.~Symp.~Principles of Programming Languages},
   publisher = {ACM Press},
   year =      1977,
}

@inproceedings{nethercote03valgrind,
    author = {N. Nethercote and J. Seward},
    title = {Valgrind: A Program Supervision Framework},
    booktitle = {ENTCS},
    volume = {89},
    issue = {2},
    publisher = {Elsevier},
    editor = {O. Sokolsky and M. Viswanathan},
    year = {2003}
}

@inproceedings{robby03,
 author = {Robby and M. Dwyer and J. Hatcliff},
 title = {Bogor: an extensible and highly-modular software model checking framework},
 booktitle = {Proc.~European Software Engineering Conf.~(ESEC'03)},
 year = {2003},
}

@book{
  instantreplay,
  key       = "Debugging parallel programs with Instant Replay",
  title     = "Debugging parallel programs with Instant Replay",
  author    = "T. J. LeBlanc and J. M. Mellor-Crummey",
  note      = "IEEE Transaction on computers C-36(4):471-482",
  year      = "1987",
  publisher = "IEEE Computer Society"

}

@inproceedings{ 
  choi98deterministic,
  author = "J.-D. Choi and H. Srinivasan",
  title  = "Deterministic Replay of Java Multithreaded Applications",
  booktitle   = "Proc.~SIGMETRICS Symp.~on Parallel and Distributed Tools",
  year   = "1998",
}

@inproceedings{praungross03,
  author={C.v. Praun and T. Gross},
  title={Static Detection of Atomicity Violations in Object-Oriented Programs},
  year=2003,
  booktitle="Proc.~Formal Techniques for Java-like Programs",
  series="Technical Reports from ETH Z{\"u}rich",
  publisher="ETH Z{\"u}rich",
  volume="408",
}

@inproceedings{wangstoller03,
  author="L. Wang and S. Stoller",
  title={Run-Time Analysis for Atomicity},
  year=2003,
  booktitle="Proc.~Run-Time Verification Workshop (RV'03)",
  series = {ENTCS},
  publisher="Elsevier",
  volume="89(2)",
}

@inproceedings{flanaganqadeer03,
  author="C. Flanagan and S. Qadeer",
  title={Types for Atomicity},
  year=2003,
  booktitle="Proc.~Workshop on Types in Language Design and Implementation
  (TLDI'03)", 
  publisher = {ACM Press},
}

@article{Artho-etal2003,
  author={C. Artho and K. Havelund and A. Biere},
  title={High-Level Data Races},
  journal={Journal on Software Testing, Verification \& Reliability {(STVR)}},
  year={2003},
  volume = {13},
  number = {4},
  publisher={John Wiley \& Sons},
}

@inproceedings{mittal98consistency,
    author = "N. Mittal and V. Garg",
    title = {Consistency Conditions for Multi-Object Distributed Operations},
    booktitle = "Intl.~Conf.~on Distributed Computing Systems",
    year = "1998",
}

@manual{j2ee,
  key = {{Sun Microsystems}},
  organization = {{Sun Microsystems}},
  title = {{Java 2 Platform Enterprise Edition} Specification},
  note = "\verb+http://java.sun.com/j2ee+",
  year = {2002},
}

@inproceedings{goldberg-havelund02,
  author = {A. Goldberg and K. Havelund},
  title = {Instrumentation of {J}ava Bytecode for Runtime Analysis},
  booktitle="Proc.~Formal Techniques for Java-like Programs",
  series="Technical Reports ETH Z{\"u}rich",
  publisher="ETH Z{\"u}rich",
  volume="408",
  year = {2003},
}

@book{lea97,
   author = {D. Lea},
   publisher = {Addison-Wesley},
   title = {Concurrent Programming in {Java}},
   year = {1997},
}

@inproceedings{havelund00,
  author = "K. Havelund",
  title = {Using Runtime Analysis to Guide Model Checking of {Java} Programs},
  booktitle = "Proc.~SPIN Workshop (SPIN'00)",
  series = "LNCS",
  volume = 1885,
  publisher = "Springer",
  year = 2000,
}

@inproceedings{havelund-rosu01-rv,
  author = {K. Havelund and G. Ro\c{s}u},
  title = {Monitoring {Java} Programs with {Java PathExplorer}},
  booktitle = {Proc.~Run-Time Verification Workshop (RV'01)},
  series = {ENTCS},
  volume = {55},
  year = {2001},
  publisher = {Elsevier},
}

@inproceedings{corbett-et-al00,
  author = "J. Corbett and M. Dwyer and J. Hatcliff and
            C. Pasareanu and Robby and S. Laubach and H. Zheng",
  title  = {{Bandera}: Extracting Finite-state Models from {Java} Source Code},
  booktitle= "Proc.~Intl.~Conf.~on Software Engineering (ICSE'00)",
  publisher = "ACM Press",
  year   = 2000,
}

@inproceedings{holzmann-smith99,
  author      = "G. Holzmann and M. Smith",
  title       = {A Practical Method for Verifying Event-Driven Software},
  booktitle= "Proc.~Intl.~Conf.~on Software Engineering (ICSE'99)",
  publisher   = "IEEE/ACM",
  year        = 1999,
}

@inproceedings{godefroid97,
  author = "P. Godefroid",
  title = {Model Checking for Programming Languages using {VeriSoft}},
  booktitle = "Proc.~ACM Symposium on Principles of Programming Languages
  (POPL'97)",
  year = 1997,
}

@inproceedings{visser-et-al00,
  author = "W. Visser and K. Havelund and G. Brat and S. Park",
  title = {Model Checking Programs},
  booktitle = "Proc.~IEEE Intl.~Conf.~Automated Software Engineeering (ASE'00)",
  year        = 2000,
}

@article{havelund-pressburger00,
  author = "K. Havelund and T. Pressburger",
  title = {Model Checking {Java} Programs using {Java PathFinder}},
  journal = "Intl.~Journal on Software Tools for Technology Transfer (STTT)",
  year = 2000,
  volume = 2,
  number = 4,
}

@techreport{detlefs-et-al98,
  author = "D. Detlefs and R. Leino and G. Nelson and
            J. Saxe",
  institution = "Compaq Systems Research Center, Palo Alto, USA",
  number = {159},
  title = {{Extended Static Checking}},
  year = 1998,
}

@inproceedings{harrow00,
  author = "J. Harrow",
  title = {Runtime Checking of Multithreaded Applications with {Visual Threads}},
  booktitle = "Proc.~SPIN Workshop (SPIN'00)",
  series = "LNCS",
  volume = 1885,
  year = 2000,
  publisher = "Springer",
}

@book{arnold-gosling96,
   author = {K. Arnold and J. Gosling},
   publisher = {Addison-Wesley},
   title = {The {Java} Programming Language},
   year = {1996},
}

@inproceedings{Artho2001,
  author={C. Artho and A. Biere},
  title={Applying Static Analysis to Large-Scale, Multithreaded {J}ava Programs.},
  editor={D. Grant},
  booktitle={Proc.~13th {ASWEC}},
  year={2001},
  publisher={IEEE Computer Society},
}

@book{GoslingJoySteeleBracha2000,
  author={J. Gosling and B. Joy and G. Steele and G. Bracha},
  title={The {Java Virtual Machine} Specification, Second Edition},
  publisher={Addison{-}Wesley},
  year={2000},
}

@mastersthesis{Bruening99systematic,
  author = "D. Bruening",
  title = {Systematic Testing of Multithreaded {J}ava Programs},
  school = "MIT",
  year = "1999",
}

@mastersthesis{eugster03,
  author = "P. Eugster",
  title = {{Java Virtual Machine} with Rollback Procedure allowing Systematic and Exhaustive Testing of Multithreaded {Java} Programs},
  school = "ETH Z{\"u}rich",
  year = "2003",
}

@inproceedings{PraunGross2001,
  author={C. von Praun and T. Gross},
  title={Object-Race Detection},
  booktitle={{OOPSLA 2001}},
  year={2001},
  publisher={ACM Press},
}

@article{savage97eraser,
    author = "S. Savage and M. Burrows and G. Nelson and P. Sobalvarro and T. Anderson",
    title = {Eraser: A Dynamic Data Race Detector for Multithreaded Programs},
    journal = "ACM Trans.~on Computer Systems",
    volume = "15",
    number = "4",
    year = "1997",
}

@book{StaerkSchmidBoerger2001,
  author={R. St{\"a}rk and J. Schmid and E. B{\"o}rger},
  title={{Java and the Java Virtual Machine}},
  publisher={Springer},
  year={2001},
}

@book{LindholmYellin1999,
  author={T. Lindholm and A. Yellin},
  title={The {Java Virtual Machine} Specification, Second Edition},
  publisher={Addison{-}Wesley},
  year={1999},
}

@book{Lea1999,
  author={D. Lea},
  title={Concurrent Programming in {Java}, Second Edition},
  publisher={Addison{-}Wesley},
  year={1999},
}

@inproceedings{SchuppanBaurBiere04,
  author = {V. Schuppan and M. Baur and A. Biere},
  title = {{JVM}-Independent Replay in {Java}},
  year = {2004},
  booktitle = {Proc.~Run-Time Verification Workshop (RV'04)},
  series = {ENTCS},
  publisher = {Elsevier},
}
